;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.include "sprites/assets.inc"
.include "entity_struct.inc"
.include "anim_structs.inc"
.globl _entity_jugador
.globl get_direccion_entity
.globl get_ptr_anim_jugador
.globl get_ptr_anim_enemigo
.globl get_vida_entity
;.globl _jugador_walkingDown

sys_save_animation_mem::            ;; guarda en la entidad pasada las primeras posiciones de memoria de la animacion jugador standing 
;; SE LE PASA HL MEM entidad
  ex de,hl
  ld (hl),#>_jugador_standing
  inc hl 
  ld (hl),#<_jugador_standing
 
ret
sys_save_animation_mem_e::          ;; guarda en la entidad pasada las primeras posiciones de memoria de la animacion mago 
;; SE LE PASA HL MEM
  ex de,hl
  ld (hl),#>_anim_mago
  inc hl 
  ld (hl),#<_anim_mago
  inc hl
  ex de,hl
  
ret

sys_save_animation_mem_s::          ;; guarda en la entidad pasada las primeras posiciones de memoria de la animacion slime
;; SE LE PASA HL MEM
  ex de,hl
  ld (hl),#>_anim_slime
  inc hl 
  ld (hl),#<_anim_slime
  inc hl
  ex de,hl
  
ret
sys_animation_one_entity_jugador::          ;; obtienen la posicion de memoria donde se encuentra el sp de la entidad  JUGADOR

  ;                              entidad [][][40][A0]        = Ulimas pos guardan pos de memoria del array de animaciones 
  ld bc,#TAM_ENTITY_JUGADOR ; pointer donde empieza animacion ;|  HL= pointer a comienzo array animacion 
  add hl, bc    ;\
  ld d,(hl)   ;/
  inc hl      ;| DE=  Pointer a array animacion       DE= [40][A0]
  ld e,(hl)   ;\
  push de
  call next_ptr_in_animation                      ;; obtienes posiciones del siguiente sprite     40A0 -> 40A2
  pop de
  ex de,hl  ;| HL = pointer a array animacion      ;;40A2 [40][00]
  ld e,(hl) ;/
  inc hl    ;|DE = pointer a sp                   ;;DE = 4000
  ld d,(hl) ;\
  ex de,hl
ret



sys_animation_one_entity_enemigo::      ;; obtienen la posicion de memoria donde se encuentra el sp de la entidad  ENEMIGO
                ;/
  ld bc,#TAM_ENTITY_ENEMIGO ; pointer donde empieza animacion ;|  HL= pointer a comienzo array animacion 
  add hl, bc    ;\
  ld d,(hl)   ;/
  inc hl      ;| DE=  Pointer a array animacion
  ld e,(hl)   ;\
  push de
  call next_ptr_in_animation  
  pop de
  ex de,hl  ;| HL = pointer a array animacion 
  ld e,(hl) ;/
  inc hl    ;|DE = pointer a sp
  ld d,(hl) ;\
  ex de,hl
ret
next_ptr_in_animation :                         ;; Coge siguientes posiciones de memoria que van de 2 en 2     40A0 -> 40A2
  ;; En DE tenemos un puntero en array animacion 
  ;; En hL puntero en array entity
  inc de      ;; Movemos array animacion al comienzo de la siguiente animacion 
  inc de 
  push hl   
  call comprobar_animacion
  pop hl 
ret
comprobar_animacion::    
  ld a,(de)
  or a
  jr nz,no_00        ;;| Comporbar que contenido en array animacion no sea 00
    inc de  
    ld a,(de)
    or a 
  jr nz,no_01        ;; | Comporbar next puntero animacion tampoco sea 00
    inc de          ;; IF DE == 00 Y next DE == 00 
    ld a,(de)
    ld (hl),a         ;; Coger las dos siguientes mosiciones de memoria que contienen las posicones memoria del principio de la animacion 
    inc de 
    dec hl            ;; Guardar principio animacion en HL
    ld a,(de)
    ld (hl),a
  jr fin_comprobacion
  no_01:
    dec de
  no_00:
    ld (hl),e       ;;IF DE != 00 y next DE != 00
    dec hl 
    ld (hl),d
  fin_comprobacion:
  
ret 


;; CONTINUAR COMENTANDO DESDE AQUI 
cambiar_anim_entity_jugador::
  ;;Pasar en hl principio entidad
  ld hl,#_entity_jugador
  push hl 
  call get_direccion_entity
  ld bc,#0x0000
  add a
  ld c,a
  ld hl,#_anim_jugador
  add hl,bc
  ex de,hl
  pop hl 
  call get_ptr_anim_jugador
  ;;; HL : entity jugador
  ;;DE :animacion 
  ld a,(de)
  ld (hl),a
  dec hl 
  inc de
  ld a,(de)
  ld (hl),a
ret
cambiar_anim_entity_enemigo::
  ld a,(hl)
  cp #1
  jp nz, type_4_anim
      call cambiar_anim_mago
     jp continue_next_enemy_anim
  type_4_anim:
    call cambiar_anim_slime
  continue_next_enemy_anim:
ret

cambiar_anim_mago:
  ;;Pasar en hl principio entidad
  push hl 
  call get_direccion_entity
  ld bc,#0x0000
  add a
  ld c,a
  ld hl,#_anim_mago
  add hl,bc
  ex de,hl
  pop hl 
  call get_ptr_anim_enemigo
  ;;; HL : entity jugador
  ;;DE :animacion 
  ld a,(de)
  ld (hl),a
  dec hl 
  inc de
  ld a,(de)
  ld (hl),a
ret


cambiar_anim_slime::
  ;;Pasar en hl principio entidad
  push hl 
  call get_direccion_entity
  ld bc,#0x0000
  add a
  ld c,a
  ld hl,#_anim_slime
  add hl,bc
  ex de,hl
  pop hl 
  call get_ptr_anim_enemigo
  ;;; HL : entity jugador
  ;;DE :animacion 
  ld a,(de)
  ld (hl),a
  dec hl 
  inc de
  ld a,(de)
  ld (hl),a
ret
cambiar_anim_vida::
  call get_vida_entity
  add a
  ld hl,#_anim_vida
  ld bc,#0x0000
  ld c,a
  add hl,bc
  ld e,(hl)
  inc hl
  ld d,(hl)
  ld h,d
  ld l,e
ret

comprobar_direccion::
  push af
  ld hl,#_entity_jugador
  call get_direccion_entity
  ld b,a
  pop af 
  cp b
  jr z, no_igual
  xor a
  no_igual:
ret