;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;ESTRUCTURAS DE LAS ENTIDADES

;;Personaje - tipo, x , y, vida , velocidad, direccion,invulnerable,animacion
;;Enemigo - tipo, x , y, vida , velocidad, direccion,invulnerable,(Ataque) -tipo,  x, y,t1,t2,animacion
;;objeto -tipo,  x, y
;;Ataque -tipo,  x, y, contador
.globl sys_save_animation_mem_e
.globl sys_save_animation_mem
.globl sys_save_animation_mem_s
.globl sys_render_shot
.globl render_fondo_borrado
.globl render_fondo_borrado_vida


.include "entity_struct.inc"
;;RESERVAS DE MEMORIA DE LAS ENTIDADES Y OTROS VALORES USADOS EN EL CODIGO 
_next_enemy::
    .ds 2
_buclee::
    .ds 1
_num_enemies::
    .ds 1
_live_enemies::
    .ds 1
_act_enemy::
    .ds 1
_last_entity_enemy::
    .ds 2
_posicion_jugador::
    .ds 2
_entity_jugador::
    .ds 9
_entity_ataque::
    .ds 6
_entity_enemigos::
    .ds 42
;;MODELOS DE DATOS PARA COPIAR EN LA MEMORIA DE ENTIDADES
_jugador_template::     ;; TEMPLATE JUAGADOR
    .db #0x00
    .db #0x40
    .db #0x80
    .db #0x05
    .db #0x01
    .db #0x01 ;;izquierda=1 ,derecha=2,abajo =4, arriba=8
    .db #0x00 ;;invulnerable
_enemigo_tipo1:         ;;TEMPLATE TIPO LEVEL 1
    .db #0x01
    .db #0x01
    .db #0x01
_enemigo_tipo2:         ;; TEMPLATE TIPO LEVEL 2
    .db #0x05
    .db #0x05
    .db #0x01

_enemigo_x1:            ;; TEMPLATE POSICION LEVEL 1
    .db #16
    .db #20
    .db #68
_enemigo_y1:
    .db #32
    .db #120
    .db #72
_enemigo_x2::             ;;TEMPLATE POSICION LEVEL 2
    .db #16
    .db #20
    .db #68

_enemigo_y2::
    .db #32
    .db #136
    .db #32

_enemigo_template:
    .db #0x05
    .db #0x08
    .db #0x01 ;izquierda=1 ,derecha=2,abajo =4, arriba=8
    .db #0x00   ;;invulnerabl
    ;;ataque
    .db #0x00 ;nodisparo=0, izquierda=1, derecha=2, arriba=3, abajo=4
    .db #0x00   ;ataque x
    .db #0x00   ;ataque y
    .db #0x00   ;tilemap1
    .db #0x00   ;tilemap2
_ataque_template:
    .db #0xfe
    .db #0x10 
    .db #0x10
    .db #0x00;contador
    .db #0x00
    .db #0x00

sys_init_entidades::        ;; LLAMADA A LA INICIALIZACION DE LAS ENTIDADES
    ld hl,#_num_enemies     ;; Inicializamos num enemigos a 0
    ld (hl),#0x00
    call init_jugador
    call init_last_entity_enemy
    call init_ataque
    ret

sys_entity_update::         ;; comprobamos 
    ;ld hl,#_entity_jugador
    ;ld bc,#TAM_ENTITY_JUGADOR  
    ld  a,(_num_enemies)        ;; Si hay enemigos vivos comprobamos el disparo del enemigo
    or a
    jp z,salto_enemigos
    call sys_enemy_comprobar_shot
    salto_enemigos:

    ret
init_jugador:               ;; COPIA EL TEMPLATE JUGADOR EN LA MEMORIA DE JUGADOR ENTITY 
    ld de,#_entity_jugador
    ld bc,#TAM_ENTITY_JUGADOR
    ld hl,#_jugador_template
    ldir
    call sys_save_animation_mem
    ret


init_enemigos_level1::              ;; INIT ENEMIGO QUE NO HACE NADA 
   ld hl,#_last_entity_enemy   ;posicion de memoria que guarda el princio de direccion a last entity
    call save_prt_in_registry   ;pasamos el contenido de last_enemy_entity a registro 
    ld bc,#0x01                    ; 
    ld hl,#_enemigo_tipo1          ;                  ;
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_x1             ;     
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_y1             ;
    ldir                           ;
    ld hl,#_enemigo_template       ;
    ld bc,#ENEMY_TEMPLATE_BASE     ;    se copia el resto (la parte comun del enemigo) en la entidad
    ldir                           ;                                                     
    call sys_save_animation_mem_e        
    ld a,(_num_enemies)                                    
    inc a                                      ;        Suma 1 a num_enemies             
    ld (_num_enemies),a                                   
    ret

init_enemigos_level2::              ;;INIT NIVEL 2 EL ENEMIGO DIAPARA
    ld hl,#_last_entity_enemy   ;posicion de memoria que guarda el princio de direccion a last entity
    call save_prt_in_registry   ;pasamos el contenido de last_enemy_entity a registro 
    ld bc,#0x01                    ; 
    ld hl,#_enemigo_tipo1          ;                  ;
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_x1             ;     
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_y1             ;
    ldir                           ;
    ld hl,#_enemigo_template       ;
    ld bc,#ENEMY_TEMPLATE_BASE     ;    se copia el resto (la parte comun del enemigo) en la entidad
    ldir                           ;                                                     
    call sys_save_animation_mem_e        
    ld a,(_num_enemies)                                    
    inc a                                      ;        Suma 1 a num_enemies             
    ld (_num_enemies),a      
    ret
    
init_enemigos_level3::     ;; NIVEL 3 , YA HAY MÁS ENEMIGOS
    bucle_create_enemies1:   ;etiqueta
    ld hl,#_last_entity_enemy   ;posicion de memoria que guarda el princio de direccion a last entity
    call save_prt_in_registry   ;pasamos el contenido de last_enemy_entity a registro 
    push de

    ld bc,#0x01                    ; 
    ld hl,#_enemigo_tipo1          ;    Se copia el valor [iteracion] del template_enemigo (TIPO) el entity con ldir 
    ld d,#0                        ;       Iteracion 1                  Iteracion2 
    ld a,(_num_enemies)            ;       E1 [01][10][11][...]         E2 [02][20][12][...]
    ld e,a                         ;
    add hl,de                      ;    Tipo[01][02][01]      pos_x[10][20][30]         pos_y[11][12][13]
    pop de                         ;
    ldir                           ;
    push de
    ld bc,#0x01                    ;
    ld hl,#_enemigo_x1             ;     
    ld d,#0                        ;
    ld a,(_num_enemies)            ;    Se copia el valor [iteracion] del template_enemigo (POS_X) en entity 
    ld e,a                         ;    
    add hl,de                      ;        
    pop de                         ;
    ldir                           ;

    push de                        ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_y1             ;
    ld d,#0                        ;
    ld a,(_num_enemies)            ;   se copia el valor [iteracion] de template enemigo (POS_Y) en entity
    ld e,a                         ;
    add hl,de                      ;
    pop de                         ;
    ldir                           ;

    ld hl,#_enemigo_template       ;
    ld bc,#ENEMY_TEMPLATE_BASE     ;    se copia el resto (la parte comun del enemigo) en la entidad
    ldir                           ;
   ; pop af
    cp #3                                      ;        IF de tipo de enemigo  
    jp nz, type_41                              ;     
        call sys_save_animation_mem_e          ;         If Tipo==01 guarda al final de la entidad la direccion de memoria
        jp continue_next_enemy1                 ;         al principio de las animaciones del enemigo tipo 01
    type_41:                                    ;         If Tipo==02 Guarda al final la direccion de memoria a las animaciones 
        call sys_save_animation_mem_s          ;         enemigo 02
    continue_next_enemy1:                                
    call update_next_ptr_last_enemy            ;        Pasa a la siguiente entidad enemigo cuyo inicio se guarda en hl 
    ld a,(_num_enemies)                                    
    inc a                                      ;        Suma 1 a num_enemies             
    ld (_num_enemies),a                        ;                             
    cp #3                                      ;             
    jr nz, bucle_create_enemies1                                     
    ld hl,#_live_enemies                                    
    ld (hl),a                                       
    ret

init_enemigos_level4::               ;;ENEMIGO NIVEL 4
    ld hl,#_last_entity_enemy   ;posicion de memoria que guarda el princio de direccion a last entity
    call save_prt_in_registry   ;pasamos el contenido de last_enemy_entity a registro 
    ld bc,#0x01                    ; 
    ld hl,#_enemigo_tipo2          ;    Se copia el valor [iteracion] del template_enemigo (TIPO) el entity con ldir                   ;
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_x2         ;     
    ldir                           ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_y2           ;
    ldir                           ;
    ld hl,#_enemigo_template       ;
    ld bc,#ENEMY_TEMPLATE_BASE     ;    se copia el resto (la parte comun del enemigo) en la entidad
    ldir                           ;                                                                   
    call sys_save_animation_mem_s        
    ld a,(_num_enemies)                                    
    inc a                                      ;        Suma 1 a num_enemies             
    ld (_num_enemies),a                        
    ld hl,#_live_enemies                                    
    ld (hl),#1              
    ret

init_enemigos_level5::     ;; NIVEL 3 , YA HAY MÁS ENEMIGOS
    bucle_create_enemies5:   ;etiqueta
    ld hl,#_last_entity_enemy   ;posicion de memoria que guarda el princio de direccion a last entity
    call save_prt_in_registry   ;pasamos el contenido de last_enemy_entity a registro 
    push de

    ld bc,#0x01                    ; 
    ld hl,#_enemigo_tipo2          ;    Se copia el valor [iteracion] del template_enemigo (TIPO) el entity con ldir 
    ld d,#0                        ;       Iteracion 1                  Iteracion2 
    ld a,(_num_enemies)            ;       E1 [01][10][11][...]         E2 [02][20][12][...]
    ld e,a                         ;
    add hl,de                      ;    Tipo[01][02][01]      pos_x[10][20][30]         pos_y[11][12][13]
    pop de                         ;
    ldir                           ;
    push de
    ld bc,#0x01                    ;
    ld hl,#_enemigo_x2             ;     
    ld d,#0                        ;
    ld a,(_num_enemies)            ;    Se copia el valor [iteracion] del template_enemigo (POS_X) en entity 
    ld e,a                         ;    
    add hl,de                      ;        
    pop de                         ;
    ldir                           ;

    push de                        ;
    ld bc,#0x01                    ;
    ld hl,#_enemigo_y2             ;
    ld d,#0                        ;
    ld a,(_num_enemies)            ;   se copia el valor [iteracion] de template enemigo (POS_Y) en entity
    ld e,a                         ;
    add hl,de                      ;
    pop de                         ;
    ldir                           ;

    ld hl,#_enemigo_template       ;
    ld bc,#ENEMY_TEMPLATE_BASE     ;    se copia el resto (la parte comun del enemigo) en la entidad
    ldir                           ;
   ; pop af
    cp #3                                      ;        IF de tipo de enemigo  
    jp nz, type_45                              ;     
        call sys_save_animation_mem_e          ;         If Tipo==01 guarda al final de la entidad la direccion de memoria
        jp continue_next_enemy1                 ;         al principio de las animaciones del enemigo tipo 01
    type_45:                                    ;         If Tipo==02 Guarda al final la direccion de memoria a las animaciones 
        call sys_save_animation_mem_s          ;         enemigo 02
    continue_next_enemy5:                                
    call update_next_ptr_last_enemy            ;        Pasa a la siguiente entidad enemigo cuyo inicio se guarda en hl 
    ld a,(_num_enemies)                                    
    inc a                                      ;        Suma 1 a num_enemies             
    ld (_num_enemies),a                        ;                             
    cp #3                                      ;             
    jr nz, bucle_create_enemies5                                     
    ld hl,#_live_enemies                                    
    ld (hl),a                                       
    ret


init_ataque::                       ;; INICIALIZA EL ATAQUE COPIANDO DESDE EL TEMPLATE A LA ENTIDAD CON LDIR
    ld de,#_entity_ataque
    ld bc,#TAM_ENTITY_ATAQUE
    ld hl,#_ataque_template
    ldir
    ret

init_last_entity_enemy:             ;; INICIALIZA EL PUNTERO DE LAS ENTITY 
    ld hl,#_last_entity_enemy
    ld de,#_entity_enemigos
    call save_registry_in_ptr
    ret

incrementa:
    push af
    ld a,b
    bucleinc:
    inc hl
    dec a
    or a
    jr nz,bucleinc
    pop af
    ret
_entity_update_pos::                  ;; ACTUALIZA LA POSICION DE LA ENTIDAD
   ;;PASARLE EN REGISTRO HL inicio struct
   ;;Pasarle en registro d X : 0xff o 0x01 Por ejemplo 
   ;;Pasarle en registro e Y 
   ;; 0 = no se mueve    || 1= positivo || 2= negativo
    inc hl 
    ld a,d
    cp #1
    jr z, se_mueve_positivo_x
    cp #2 
    jr z, se_mueve_negativo_x
    jr comprobar_y
    se_mueve_positivo_x:
        ld a,(hl)
        inc c
        inc a   
        cp c        
        jr nz ,fin
            dec c
            call arreglo
        ret
    se_mueve_negativo_x:
        dec c
        ld a,(hl)
        dec a   
        cp c
        jr nz ,fin
            inc c
            call arreglo
        ret
        

    comprobar_y:
    
    inc hl ; CAMBIO A POS MEM Y 
    ;COMPROBAR MOV Y
    ld a,e
    cp #1
    jr z, se_mueve_positivo_y
    cp #2 
    jr z, se_mueve_negativo_y
    jr fin
    se_mueve_positivo_y:
        ld a,(hl)
        push hl
        inc a   
        cp c
        jr nz ,passD
            dec c
            pop hl
            call arreglo
            jr fin
        passD:
        inc a   
        cp c
        pop hl
        jr nz ,fin
        dec c
        pop hl
        call arreglo
    jr fin

    se_mueve_negativo_y:
        dec c
        ld a,(hl)
        push hl
        dec a   
        cp c
        jr nz ,passI
            inc c
            pop hl
            call arreglo
        ret
        passI:
        dec a   
        cp c
        or a
        pop hl
        jr nz ,fin
        inc c
        pop hl
        call arreglo
    ret
    fin:
    ld (hl),a 
    ld a,#0xff
    ret
arreglo:
    ld a,c
    ld (hl),a
    ret

entity_update_vida::                    ;;RESTA UNA VIDA A LA ENTIDAD 
    ;;Pasar en hl entidad
    ;;y resta 1 a vida
    ld d, h
    ld e,l
    ld bc,#POS_VIDA                     ; se queda en hl laposicion de memoria donde esta la posicion de la vida
    add hl,bc
    ld a,(hl)                           ; coge el valor de la vida
    sub #1                              ; resta 1
    ld (hl),a                           ; lo almacena 
    or a                                ; IF Vida == 0 llama a entity_update estate, si no continua
    jr z, entity_update_vida_state
    ld h, d
    ld l,e
    ret

entity_update_vida_state:             ;; SI MUERTO CAMBIA EL TIPO DE LA ENTIDAD A DEAD
    ld h,d
    ld l,e
    ld (hl),#PLAYER_DEAD                ;guarda en hl el principio de la entidad donde esta el tipo, y lo pasa a FF
    push hl 
    call render_fondo_borrado
    pop hl 
    call render_fondo_borrado_vida
    call damage_live_enemies
    ret

update_entity_ataque_xy::               ; actualiza el ataque en x e y 
    ;pasarle en hl #entity ataque 
    ;pasarle en d -> x
    ;pasarle en e -> y 
    inc hl
    call save_registry_in_ptr           ; guarda lo que hay en el registro d y e en la posicion de memoria correspondiente de la entidad 
    ret
entity_update_tipo:                     ; Cambia el tipo de la entidad
    ;pasarle entity en hl 
    ;pasarle tipo en d
    ld (de),a
    ret
entity_update_velocidad:                ; Cambia la velocidad de la entidad
    ;;Pasar en hl entidad
    ;;pasar en D velocidad
    ld bc,#POS_VELOCIDAD
    add hl,bc
    ld a,d
    ld (hl),a
    ret

update_direccion_entity::               ;; guarda el valor pasado en d en la poscion de memoria correspondiente a la direccion dela entidad
    ;;Pasar en hl entidad 
    ;; pasar en d, valor direccion 
    ld bc,#POS_DIRX ; pointer donde empieza la direccion 
    add hl, bc 
    ld (hl),d
    ret
get_direccion_entity::                  ;; devuelve la direccion de entidad
    ld bc,#POS_DIRX ; 
    add hl, bc 
    ld a,(hl)
    ret
get_ptr_anim_jugador::                   ;Devuelve la posicion de memoria donde se almacena la animacion de jugador 
    ;Se le pasa en HL la entidad
    ld bc,#POS_ANIMACION_JUGADOR+1; pointer donde empieza animacion ;|  HL= pointer a comienzo array animacion 
    add hl, bc 
    ret
get_ptr_anim_enemigo::                   ;Devuelve la posicion de memoria donde se almacena la animacion de Enemigo
    ;Se le pasa en HL la entidad
    ld bc,#TAM_ENTITY_ENEMIGO+1; pointer donde empieza animacion ;|  HL= pointer a comienzo array animacion 
    add hl, bc 
    ret
get_vida_entity::                         ;Devuelve la vida de la entidad 
    ; se le pasa la entidad en HL 
    ld bc,#POS_VIDA
    add hl, bc 
    ld a,(hl)
    ret
sys_enemy_comprobar_shot::                 
    ld hl,#_entity_enemigos         
    xor a                           ;;inicializa el registro A a 0
    bucle_enemigos_shot:            
        push af 
        push hl 
        ld bc,#TAM_ENTITY_ENEMIGO  
        call sys_enemy_shot
        pop hl
        call get_next_enemy_ptr
        ld a,(_num_enemies)
        ld b,a
        pop af
        inc a 
    cp b
    jr nz, bucle_enemigos_shot
    ret
sys_enemy_shot:
    ld bc,#POS_DISPARO_ENEMIGO
    add hl,bc
    ld a,(hl)
    cp #0
    jr z,fin_shot
    cp #5
    jr z,fin_shot
    call sys_render_shot
    fin_shot:
    ret
entity_ataque_fin:
    ld hl,#_entity_ataque
    ld a,(hl)
    cp #0xff
    jr nz, ataque_no_ff
    call render_fondo_borrado
     ataque_no_ff:
    ret
get_next_enemy_ptr::     ;DEVUELVE PUNTERO NEXT ENTITY
    ;;Pasarle por hl #entity_enemy
    ld bc, #TAM_ENTITY_ENEMIGO_TOTAL
    add hl,bc
    ret
get_prev_enemy_ptr:     ;DEVUELVE PUNTERO NEXT ENTITY
    ;;Pasarle por hl #entity_enemy1
    ld bc, #0xfff4
    add hl,bc
    ret

update_next_ptr_last_enemy:     ;; ESTE METODO SUMA A LAST ENEMY 12 PARA PASAR A NEXT ENEMY Y GUARDA EL VALOR 
    ld hl,#_last_entity_enemy       
    call save_prt_in_registry
    ex de,hl
    call get_next_enemy_ptr
    ex de,hl
    ld (hl),e
    dec hl 
    ld (hl),d
    ret
save_prt_in_registry:       ;; GUARDA EN DE el valor de PTR a MEMORIA
    ld d,(hl)
    inc hl 
    ld e,(hl)
    ret

save_registry_in_ptr:       ;;GUARDA EN MEMORIA EL VALOR DE UN REGISTRO
    ld (hl),d
    inc hl
    ld (hl),e
    ret

update_live_enemies::           ;; guarda el valor de a en live_enemies
    ld (_live_enemies),a
    
ret
damage_live_enemies::           ;;suma 1 a live enemies
    push hl
    ld hl,#_live_enemies
    ld a, (hl)
    dec a
    ld (_live_enemies),a
    pop hl 
ret