;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.globl sys_render_update_borrado
.globl init_enemigos_level1
.globl init_enemigos_level2
.globl init_enemigos_level3
.globl init_enemigos_level4
.globl init_enemigos_level5
.globl sys_render_update
.globl sys_render_init
.globl sys_init_entidades
.globl _live_enemies
.globl update_live_enemies
.globl colisiones_init
.globl _init
.globl render_inicio
.globl sys_render_tilemap
.globl render_TheEnd   
.globl _mapa
.globl _mapa2
.globl _mapa3
_nivel::
    .ds 1
init_nivel::
    call _init

ret
nivel1::                  ;; INICIALIZA NIVEL; INICIALIZA: RENDER, MAPA, ENTIDADES, Y ENEMIGOS
    ld hl,#_nivel                       
    ld (hl),#0x01                           
    ld a,#0x01
    call update_live_enemies
    ld de, #_mapa
    call sys_render_tilemap 
    call sys_init_entidades
    call init_enemigos_level1
    call init_nivel
    call colisiones_init

ret

comprobar_partida::                  ;; SI ENEMIGOS VIVOS == 0 -> HAS PASADO DE NIVEL      

    ld a,(_live_enemies)                
    or a                                        
    jr nz, no_pasar_de_nivel                        
        ;call sys_render_init          ; VUELVES a inicializar render y mapa  
        call sys_render_tilemap       ;                 
        ld hl,#_nivel                     
        ld a,(hl)                     ; Sumas 1 a Nivel  
        inc a                         ;  
        ld (hl),a                     ;      
        ;;ESTO CREO QUE NO HACE FALTA 
        ;call sys_render_update_borrado                  
        call init_next_level                      
    no_pasar_de_nivel:

ret 
sabernivel::                            ;; IF PARA SABER EN QUE NIVEL NOS ENCONTRAMOS Y POR TANTO QUE MAPA USAMOS 
ld a,(_nivel)
    cp #1
    jp nz,no_11
        ld de,#_mapa
        jr finalsa
    no_11:
    cp #2 
    jr nz, no_22                    ;; Nivel 2
        ld de,#_mapa
        jr finalsa
    no_22:                           ;; Nivel 3
    cp #3
    jr nz, no_33
        ld de,#_mapa2
        jr finalsa
    no_33:                           ;; Nivel 4
    cp #4
    jr nz, no_44
        ld de,#_mapa3
        jp finalsa
    no_44:
    cp #5                           ;; Nivel 5
    jp nz,finalsa
        ld de,#_mapa3
    finalsa:


ret 
init_next_level:                    ;; IF para inicializar niveles
    ld a,(_nivel)
    cp #2 
    jr nz, no_2                     ;; Nivel 2
        call nivel_2
        jp final
    no_2:                           ;; Nivel 3
    cp #3
    jr nz, no_3
        call nivel_3
        jp final
    no_3:                           ;; Nivel 4
    cp #4
    jr nz, no_4
        call nivel_4
        jp final
    no_4:                           ;; Nivel 5
    cp #5
    jr nz,final_partida
        call nivel_5
        jp final
    final_partida:
    cp #6
    jr nz, final                       ;; FINAL 
      call render_TheEnd
      ld a,#0xff
    final:
ret 
nivel_2:                            ;; Init nivel 2
    ld a,#0x01
    call update_live_enemies
    ld de, #_mapa
    call sys_render_tilemap 
    call sys_init_entidades
    call init_enemigos_level2
    call init_nivel
    call colisiones_init
    
ret

nivel_3:                            ;; Init nivel 3
    ld a,#0x03
    call update_live_enemies
    ld de, #_mapa2
    call sys_render_tilemap 
    call sys_init_entidades
    call init_enemigos_level3
    call colisiones_init
    
   
ret 

nivel_4:                            ; Init nivel 4
    ld a,#0x01
    call update_live_enemies
    call sys_init_entidades
    ld de, #_mapa3
    call sys_render_tilemap 
    call init_enemigos_level4
    call init_nivel
    call colisiones_init
    ; call sys_render_tilemap
ret 
nivel_5:                                ;; Init Nivel 5
    ld a,#0x03
    call update_live_enemies
    call sys_init_entidades
    ld de, #_mapa3
    call sys_render_tilemap 
    call init_enemigos_level5
    call init_nivel
    call colisiones_init
   

ret 
nivel_fin::                             ;; FIN FONDO 
    ld de, #_mapa
    call sys_render_tilemap 
ret 