;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSprite_asm
.globl _mapatileset_00
.globl _entity_jugador
.globl _entity_enemigos
.globl _entity_ataque
.globl cpct_drawSolidBox_asm
.globl _num_enemies
.globl get_next_enemy_ptr
.globl cambiar_anim_vida
.globl cpct_drawStringM0_asm  
.globl cpct_drawStringM1_asm  
.globl get_direccion_entity
.globl cpct_setCRTCReg_asm
.globl sys_animation_one_entity_jugador
.globl sys_animation_one_entity_enemigo
.include "cpctelera.h.s"
.include "sprites/assets.inc"

.include "cpctelera.s"
.include "mapas/archivomapa.h.s"
.include "mapas/archivomapa2.h.s"
.include "mapas/archivomapa3.h.s"


.include "entity_struct.inc"


string: .asciz "ENTER to play";
stringEnd: .asciz "YOU WIN!";
buffer:: .dw 0xC000
_last_pos_personaje::
    .ds 3
sys_render_init::       ;;INICIALIZA LA PANTALLA Y LOS MODOS
    ld c,#0
    call cpct_setVideoMode_asm
    ld hl,#_g_palette
    ld de,#16
    call cpct_setPalette_asm
    cpctm_setBorder_asm HW_BLACK

    ret
sys_render_tilemap::
    push de
    ld bc, #0x1414
    ld de, #20
    ld hl, #_mapatileset_00
    call cpct_etm_setDrawTilemap4x8_ag_asm
    ld hl, (buffer)
    pop de
    call cpct_etm_drawTilemap4x8_ag_asm
ret


sys_render_update::                     ;; RENEDERIZA TODAS LAS ENTIDADES
    ld a,(_num_enemies)                 ; guarda el numero de enemigos en a
    or a                                ; si hay 1 o mas enemigos comienza a renderizarlos
    jp z,final 
    xor a
    ld hl,#_entity_enemigos
    bucle_render_enemigos:              ;BUCLE ENEMIGOS
        push af                         ; 
        ld a,(hl)                       ; si el enemigo esta vivo != FF
        cp #0xff                        ; 
        jr z,next_enemy_render                      
            push hl                         ;   
            push hl                         ;  Guarda HL 
            push hl                         ;   
            call sys_render_one_entity      ; Llama al renderizado de entidades
            pop hl                          
            call sys_render_vida_entity     ; Llama al renderizado de vida    
            pop hl                          
            call render_sp_vida             ; Renderiza el sprite de vida
            pop hl                              
        next_enemy_render:                  ; Pasa a la direccion de memoria donde esta la siguiente entidad
        call get_next_enemy_ptr                 
        ld a,(_num_enemies)                 ;    
        ld b,a                              ;
        pop af                              ;    Comprueba que haya mas enemigos
        inc a                               ;    
        cp b                                ;
        jr nz, bucle_render_enemigos
    final:
    ld hl,#_entity_jugador                  ;  Llama a la clase renderizado con hl jugador 
    call sys_render_one_entity              ;    
   
    ld hl,#_entity_ataque                   ;  Llama a la clase renderizado con hl ataque
    call sys_render_one_entity              ; 
   
    ret
sys_render_update_borrado::                 ;; ESTE METODO BORRA LAS ENTIDADES CUANDO MUEREN EN PANTALLA
    ld a,(_num_enemies)
    or a                        
    jp z,final_b
    xor a                           
    ld hl,#_entity_enemigos                             
    bucle_render_enemigos_b:                   ; BUCLE ENEMIGOS         
        push af                         
        ld a,(hl)                                       
        cp #0xff                            
        jr z,next_enemy_render_b                ;                                           
            push hl                             ;     
            push hl                             ;     Borrado de sprites enemigos y sprite de vida
            push hl                             ;                                 
            call render_fondo_borrado           ;                                         
            pop hl                              ; 
            call sys_render_vida_entity         ;                                                     
            pop hl                              ; 
            call render_fondo_borrado_vida      ;                                                 
            pop hl                              
        next_enemy_render_b:                                         
        call get_next_enemy_ptr                 ;         
        ld a,(_num_enemies)                     ;   Comprueba si ha mas enemigos que recorrer en el bucle                            
        ld b,a                                  ;
        pop af                                  ;      
        inc a                                   ;     
        cp b                                    ;            
        jr nz, bucle_render_enemigos_b                                      
    final_b:
    ld hl,#_entity_ataque                       ;   Borra ataque
    call render_fondo_borrado                   ;                          
    
    ld hl,#_entity_jugador                      ;                                    
    push hl                                     ;
    call render_fondo_borrado                   ;   Borra sprite jugador y sprite vida jugador 
    pop hl                                      ;             
    call render_fondo_borrado_vida              ;        
    ret

sys_render_one_entity:      ;;RENDERIZA UNA ENTIDAD Y LA IDENTIFICA (JUGADOR , OBJETO O ENEMIGO) CON IFS
    ;;se le pasa en hl puntero a primera direccion DE LA entidad
    push hl
    call sys_render_entity              ; Obtiene a posicion en pantalla de la entidad
    pop hl
    ld a,(hl)

    cp #TYPE_JUGADOR                    ;
    jr nz,mago_sp                       ;
    push hl                             ;       enderiza Tipo Jugador                     
    push hl                             ;
    call render_sp_jugador              ;          
    pop hl                                    
    call sys_render_vida_entity         ;          ESTO RENDER 
    pop hl                              ;          VIDA 
    call render_sp_vida                 ;          JUGADOR
    jr fin

    mago_sp:                            ;        
    cp #TYPE_MAGO                       ;         Renderiza TIPO MAGO                            
    jr nz,slime_sp                      ;            
    call render_sp_mago                 ;                
    jr fin                              ;    

    slime_sp:                           ;                                    
    cp #TYPE_SLIME                      ;         Renderiza tipo slime               
    jr nz,ataque_sp                     ;            
    call render_sp_slime                ;                    
    jr fin                                  

    ataque_sp:
    cp #TYPE_ATAQUE               
    jr nz,fin
    call render_sp_ataque
    fin:
    ret

sys_render_entity:              ;;LOCALIZA LA POSISION DE MEMORIA DONDE PINTAR
    ld   de, (buffer)
    inc hl 
    ld  c,(hl)  ;x
    inc hl      
    ld  b,(hl) ;y
    call cpct_getScreenPtr_asm
    ex de,hl
    ret

sys_render_vida_entity:              ;;LOCALIZA LA POSISION DE MEMORIA DONDE PINTAR
    ld   de, (buffer)                
    inc hl 
    ld  c,(hl)  ;x                  ;; Le suma 4 posiciones en y para encontrarse encima del sprite 
    
    inc hl      
    ld  b,(hl) ;y
    dec b 
    dec b 
    dec b
    dec b
    call cpct_getScreenPtr_asm
    ex de,hl
    ret

;sys_render_entity_borrado:   
;    ld   de, (buffer)
;    inc hl 
;    ld  c,(hl)  ;x 
;    inc hl          
;    ld  b,(hl) ;y
;    call cpct_getScreenPtr_asm
;    ex de,hl
;    ret

render_fondo_borrado::                      ;; Dibuja una caja del color de fondo encima de las entidades       TAM = sprite entidad
    ;call  sys_render_entity_borrado
    call  sys_render_entity
    ld b,#SP_ENEMIGO_H
    ld c,#SP_ENEMIGO_W
    ld a, #0x00     ;;Esto se cambia por 0
    call cpct_drawSolidBox_asm
ret 
render_fondo_borrado_slime::                      ;; Dibuja una caja del color de fondo encima de las entidades       TAM = sprite entidad
    ;call  sys_render_entity_borrado
    call  sys_render_entity
    ld b,#SP_SLIME_H
    ld c,#SP_SLIME_W
    ld a, #0x00     ;;Esto se cambia por 0
    call cpct_drawSolidBox_asm
ret 
render_fondo_borrado_vida::                 ;; Dibuja una caja del color de fondo encima de la vida            TAM = Sprite vida
    call sys_render_vida_entity
    ld b,#SP_VIDA_H
    ld c,#SP_VIDA_W
    ld a, #0x00
    call cpct_drawSolidBox_asm
ret 
render_fondo_borrado_shot::                  ;; Dibuja una caja del color de fondo encima del disparo          TAM = Sprite vida
    ; call sys_render_entity_borrado
    call  sys_render_entity
    ld b,#SP_SHOT_H
    ld c,#SP_SHOT_W
    ld a, #0x00
    call cpct_drawSolidBox_asm
ret 

sys_render_shot::                           ;; RENDERZIZA EL SPRITE DE DISPARO 
    call sys_render_entity  
    call render_sp_shot
    ret

render_sp_jugador:                          ;; RENDERIZA EL SPRITE DE  JUGADOR 
    push de
    ld bc,#TAM_ENTITY_ENEMIGO         
    call sys_animation_one_entity_jugador   ;; Actualiza el sprite de la animacion a renderizar y devuleve posicion en memoria
    pop de

    ld b,#SP_PERSONAJE_H
    ld c,#SP_PERSONAJE_W
    call cpct_drawSprite_asm
    ret
render_sp_mago:                             ;; RENDERIZA EL SPRITE DE MAGO
    push de
    ld bc,#TAM_ENTITY_ENEMIGO         
    call sys_animation_one_entity_enemigo      ;; Devuelve la primera por memoria del sprite siguiente de la animacion 
    pop de
    
    ld b,#SP_ENEMIGO_H
    ld c,#SP_ENEMIGO_W
    call cpct_drawSprite_asm
    ret
render_sp_slime:                              ;; RENDERIZA EL SPRITE DE SLIME
    push de
    ld bc,#TAM_ENTITY_ENEMIGO         
    call sys_animation_one_entity_enemigo       ;; Actualiza el sprite de la animacion a renderizar y devuleve posicion en memoria
    pop de
    ld b,#SP_SLIME_H
    ld c,#SP_SLIME_W
    call cpct_drawSprite_asm
    ret
render_sp_vida:                            ;; RENDERIZA EL SPRITE DE VIDA
    push de 
    call cambiar_anim_vida                  ;; coge la vida de la entidad y calcula principio memoria al sprite vida
    pop de
    ld b,#SP_VIDA_H
    ld c,#SP_VIDA_W
    call cpct_drawSprite_asm
    ret
render_sp_ataque:                           ;; RENDERIZA EL SPRITE DE ATAQUE
    ld hl,#_sp_ataque
    ld b,#SP_ATAQUE_H
    ld c,#SP_ATAQUE_W
    call cpct_drawSprite_asm
    ret

render_sp_shot:                             ;; RENDERIZA EL SPRITE DE SHOT
    ld hl,#_sp_shot
    ld b,#SP_SHOT_H
    ld c,#SP_SHOT_W
    call cpct_drawSprite_asm
    ret

get_screen_ptr:                             ;; Devuelve puntero a posicion memoria donde renderizar 
    ;; se le pasa x e y en registros b y c 
    ld de,(buffer)
    call cpct_getScreenPtr_asm
    ex de,hl
ret

;; RENDER MENU INICIO Y CONTUNACION 
get_menu_string:                            ;; Escribe en pantalla spring 
    ;ld  b,y
    ;ld  c,x 
   
    ld b,#130
    ld c,#15
    call get_screen_ptr
    ex de,hl
    call cpct_drawStringM0_asm
ret

render_menu_logo:                         ;; Renderiza el Logo de ARYAN en pantalla
    ld  b,#35 ;y
    ld  c,#27;x 
    call get_screen_ptr
    ld hl,#_sp_logo
    ld b,#SP_LOGO_H
    ld c,#SP_LOGO_W
    call cpct_drawSprite_asm
ret 


render_menu_fondo:                         ;; Renderiza un cuadrado del color del fondo para escribir encima 
    ld  b,#25 ;y
    ld  c,#9;x 
    call get_screen_ptr
    ld b,#150
    ld c,#64
    ld a,#0x00
    call cpct_drawSolidBox_asm
ret 

render_menu_controles:                      ;; REnderiza sprites del menu

    ld  b,#60 ;y                             ;            
    ld  c,#20;x                              ;               
    call get_screen_ptr                      ;   DIBUJA SPRITE DE CONTROLES                    
    ld hl,#_sp_controles                     ;   
    ld b,#SP_CONTROLES_H                     ;   
    ld c,#SP_CONTROLES_W                     ;   
    call cpct_drawSprite_asm                 ;       

    ld  b,#72 ;y                             ;   
    ld  c,#50;x                              ;  DIBUJA SPRITE DE SPACIO 
    call get_screen_ptr                      ;       
    ld hl,#_sp_controles_space               ;       
    ld b,#SP_CONTROLES_SPACE_H               ;       
    ld c,#SP_CONTROLES_SPACE_W               ;       
    call cpct_drawSprite_asm                 ;       

    ld  b,#90 ;y                             ;    
    ld  c,#22;x                              ;   DIBUJA SPRITE TEXTO "MOVE"
    call get_screen_ptr                      ;          
    ld hl,#_sp_moverse_s                     ;          
    ld b,#SP_MOVERSE_S_H                     ;      
    ld c,#SP_MOVERSE_S_W                     ;              
    call cpct_drawSprite_asm                 ;              

    ld  b,#90 ;y                             ;                                  
    ld  c,#51;x                              ;                              
    call get_screen_ptr                      ;    DIBUJA SPRITE TEXTO "ATTACK"                              
    ld hl,#_sp_atacar_s                      ;                                  
    ld b,#SP_ATACAR_S_H                      ;   
    ld c,#SP_ATACAR_S_W                      ;                              
    call cpct_drawSprite_asm                 ;                                  
ret 

render_inicio::                             ;; LLAMA A TODOS LOS METODOS ANTERIORES PARA CREAR MENU INICIO                 
    call render_menu_fondo
    call render_menu_logo
    call render_menu_controles
    ld iy,#string
    call get_menu_string

ret

render_continue::                            ;; LLAMA A TODOS LOS METODOS ANTERIORES PARA CREAR MENU CONTINUA           
    call render_menu_fondo
    call render_menu_logo
    ld iy,#string
    call get_menu_string

ret
render_TheEnd::                            ;; LLAMA A TODOS LOS METODOS ANTERIORES PARA CREAR MENU CONTINUA           
    call render_menu_fondo
    call render_menu_logo
    ld iy,#stringEnd
    call get_menu_string
ret